# Check if collection exits in database and initialize database only if not
# on command fail restart service
function initialize {
  echo "Initialize coverage types"
  python3 manage.py coveragetype import /rgbnir_definition.json --traceback
  # PL00
  python3 manage.py producttype create "${COLLECTION}"_Product_PL00 --traceback \
      --coverage-type "RGBNir"
  python3 manage.py browsetype create "${COLLECTION}"_Product_PL00 --traceback \
      --red "red" \
      --green "green" \
      --blue "blue" \
      --red-range 1000 15000 \
      --green-range 1000 15000 \
      --blue-range 1000 15000 \
      --red-nodata 0 \
      --green-nodata 0 \
      --blue-nodata 0
  python3 manage.py browsetype create "${COLLECTION}"_Product_PL00 "TRUE_COLOR" --traceback \
      --red "red" \
      --green "green" \
      --blue "blue" \
      --red-range 1000 15000 \
      --green-range 1000 15000 \
      --blue-range 1000 15000 \
      --red-nodata 0 \
      --green-nodata 0 \
      --blue-nodata 0
  python3 manage.py browsetype create "${COLLECTION}"_Product_PL00 "FALSE_COLOR" --traceback \
      --red "nir" \
      --green "red" \
      --blue "green" \
      --red-range 1000 15000 \
      --green-range 1000 15000 \
      --blue-range 1000 15000 \
      --red-nodata 0 \
      --green-nodata 0 \
      --blue-nodata 0
  python3 manage.py browsetype create "${COLLECTION}"_Product_PL00 "NDVI" --traceback \
      --grey "(nir-red)/(nir+red)" --grey-range -1 1
  # DM02
  python3 manage.py producttype create "${COLLECTION}"_Product_DM02 --traceback \
      --coverage-type "RGBNir"
  python3 manage.py browsetype create "${COLLECTION}"_Product_DM02 --traceback \
      --red "red" \
      --green "green" \
      --blue "blue" \
      --red-range 250 11500 \
      --green-range 600 10000 \
      --blue-range 1300 8500 \
      --red-nodata 0 \
      --green-nodata 0 \
      --blue-nodata 0
  python3 manage.py browsetype create "${COLLECTION}"_Product_DM02 "TRUE_COLOR" --traceback \
      --red "red" \
      --green "green" \
      --blue "blue" \
      --red-range 250 11500 \
      --green-range 600 10000 \
      --blue-range 1300 8500 \
      --red-nodata 0 \
      --green-nodata 0 \
      --blue-nodata 0
  python3 manage.py browsetype create "${COLLECTION}"_Product_DM02 "FALSE_COLOR" --traceback \
      --red "nir" \
      --green "red" \
      --blue "green" \
      --red-range 400 28000 \
      --green-range 250 11500 \
      --blue-range 600 10000 \
      --red-nodata 0 \
      --green-nodata 0 \
      --blue-nodata 0
  python3 manage.py browsetype create "${COLLECTION}"_Product_DM02 "NDVI" --traceback \
      --grey "(nir-red)/(nir+red)" --grey-range -1 1
  # KS03
  python3 manage.py producttype create "${COLLECTION}"_Product_KS03 --traceback \
      --coverage-type "RGBNir"
  python3 manage.py browsetype create "${COLLECTION}"_Product_KS03 --traceback \
      --red "red" \
      --green "green" \
      --blue "blue" \
      --red-range 1 10000 \
      --green-range 1 10000 \
      --blue-range 1 10000 \
      --red-nodata 0 \
      --green-nodata 0 \
      --blue-nodata 0
  python3 manage.py browsetype create "${COLLECTION}"_Product_KS03 "TRUE_COLOR" --traceback \
      --red "red" \
      --green "green" \
      --blue "blue" \
      --red-range 1 10000 \
      --green-range 1 10000 \
      --blue-range 1 10000 \
      --red-nodata 0 \
      --green-nodata 0 \
      --blue-nodata 0
  python3 manage.py browsetype create "${COLLECTION}"_Product_KS03 "FALSE_COLOR" --traceback \
      --red "nir" \
      --green "red" \
      --blue "green" \
      --red-range 1 10000 \
      --green-range 1 10000 \
      --blue-range 1 10000 \
      --red-nodata 0 \
      --green-nodata 0 \
      --blue-nodata 0
  python3 manage.py browsetype create "${COLLECTION}"_Product_KS03 "NDVI" --traceback \
      --grey "(nir-red)/(nir+red)" --grey-range -1 1
  # KS04
  python3 manage.py producttype create "${COLLECTION}"_Product_KS04 --traceback \
      --coverage-type "RGBNir"
  python3 manage.py browsetype create "${COLLECTION}"_Product_KS04 --traceback \
      --red "red" \
      --green "green" \
      --blue "blue" \
      --red-range 1 10000 \
      --green-range 1 10000 \
      --blue-range 1 10000 \
      --red-nodata 0 \
      --green-nodata 0 \
      --blue-nodata 0
  python3 manage.py browsetype create "${COLLECTION}"_Product_KS04 "TRUE_COLOR" --traceback \
      --red "red" \
      --green "green" \
      --blue "blue" \
      --red-range 1 10000 \
      --green-range 1 10000 \
      --blue-range 1 10000 \
      --red-nodata 0 \
      --green-nodata 0 \
      --blue-nodata 0
  python3 manage.py browsetype create "${COLLECTION}"_Product_KS04 "FALSE_COLOR" --traceback \
      --red "nir" \
      --green "red" \
      --blue "green" \
      --red-range 1 10000 \
      --green-range 1 10000 \
      --blue-range 1 10000 \
      --red-nodata 0 \
      --green-nodata 0 \
      --blue-nodata 0
  python3 manage.py browsetype create "${COLLECTION}"_Product_KS04 "NDVI" --traceback \
      --grey "(nir-red)/(nir+red)" --grey-range -1 1
  # PH1A
  python3 manage.py producttype create "${COLLECTION}"_Product_PH1A --traceback \
      --coverage-type "RGBNir"
  python3 manage.py browsetype create "${COLLECTION}"_Product_PH1A  --traceback \
      --red "red" \
      --green "green" \
      --blue "blue" \
      --red-range 1 2000 \
      --green-range 1 2000 \
      --blue-range 1 2000 \
      --red-nodata 0 \
      --green-nodata 0 \
      --blue-nodata 0
  python3 manage.py browsetype create "${COLLECTION}"_Product_PH1A "TRUE_COLOR" --traceback \
      --red "red" \
      --green "green" \
      --blue "blue" \
      --red-range 1 2000 \
      --green-range 1 2000 \
      --blue-range 1 2000 \
      --red-nodata 0 \
      --green-nodata 0 \
      --blue-nodata 0
  python3 manage.py browsetype create "${COLLECTION}"_Product_PH1A "FALSE_COLOR" --traceback \
      --red "nir" \
      --green "red" \
      --blue "green" \
      --red-range 1 2000 \
      --green-range 1 2000 \
      --blue-range 1 2000 \
      --red-nodata 0 \
      --green-nodata 0 \
      --blue-nodata 0
  python3 manage.py browsetype create "${COLLECTION}"_Product_PH1A "NDVI" --traceback \
      --grey "(nir-red)/(nir+red)" --grey-range -1 1
  # PH1B
  python3 manage.py producttype create "${COLLECTION}"_Product_PH1B --traceback \
      --coverage-type "RGBNir"
  python3 manage.py browsetype create "${COLLECTION}"_Product_PH1B --traceback \
      --red "red" \
      --green "green" \
      --blue "blue" \
      --red-range 1 2000 \
      --green-range 1 2000 \
      --blue-range 1 2000 \
      --red-nodata 0 \
      --green-nodata 0 \
      --blue-nodata 0
  python3 manage.py browsetype create "${COLLECTION}"_Product_PH1B "TRUE_COLOR" --traceback \
      --red "red" \
      --green "green" \
      --blue "blue" \
      --red-range 1 2000 \
      --green-range 1 2000 \
      --blue-range 1 2000 \
      --red-nodata 0 \
      --green-nodata 0 \
      --blue-nodata 0
  python3 manage.py browsetype create "${COLLECTION}"_Product_PH1B "FALSE_COLOR" --traceback \
      --red "nir" \
      --green "red" \
      --blue "green" \
      --red-range 1 2000 \
      --green-range 1 2000 \
      --blue-range 1 2000 \
      --red-nodata 0 \
      --green-nodata 0 \
      --blue-nodata 0
  python3 manage.py browsetype create "${COLLECTION}"_Product_PH1B "NDVI" --traceback \
      --grey "(nir-red)/(nir+red)" --grey-range -1 1
  # SP06
  python3 manage.py producttype create "${COLLECTION}"_Product_SP06 --traceback \
      --coverage-type "RGBNir"
  python3 manage.py browsetype create "${COLLECTION}"_Product_SP06 --traceback \
      --red "red" \
      --green "green" \
      --blue "blue" \
      --red-range 1000 20000 \
      --green-range 1000 20000 \
      --blue-range 1000 20000 \
      --red-nodata 0 \
      --green-nodata 0 \
      --blue-nodata 0
  python3 manage.py browsetype create "${COLLECTION}"_Product_SP06 "TRUE_COLOR" --traceback \
      --red "red" \
      --green "green" \
      --blue "blue" \
      --red-range 1000 20000 \
      --green-range 1000 20000 \
      --blue-range 1000 20000 \
      --red-nodata 0 \
      --green-nodata 0 \
      --blue-nodata 0
  python3 manage.py browsetype create "${COLLECTION}"_Product_SP06 "FALSE_COLOR" --traceback \
      --red "nir" \
      --green "red" \
      --blue "green" \
      --red-range 1000 20000 \
      --green-range 1000 20000 \
      --blue-range 1000 20000 \
      --red-nodata 0 \
      --green-nodata 0 \
      --blue-nodata 0
  python3 manage.py browsetype create "${COLLECTION}"_Product_SP06 "NDVI" --traceback \
      --grey "(nir-red)/(nir+red)" --grey-range -1 1
  # SP07
  python3 manage.py producttype create "${COLLECTION}"_Product_SP07 --traceback \
      --coverage-type "RGBNir"
  python3 manage.py browsetype create "${COLLECTION}"_Product_SP07 --traceback \
      --red "red" \
      --green "green" \
      --blue "blue" \
      --red-range 1000 20000 \
      --green-range 1000 20000 \
      --blue-range 1000 20000 \
      --red-nodata 0 \
      --green-nodata 0 \
      --blue-nodata 0
  python3 manage.py browsetype create "${COLLECTION}"_Product_SP07 "TRUE_COLOR" --traceback \
      --red "red" \
      --green "green" \
      --blue "blue" \
      --red-range 1000 20000 \
      --green-range 1000 20000 \
      --blue-range 1000 20000 \
      --red-nodata 0 \
      --green-nodata 0 \
      --blue-nodata 0
  python3 manage.py browsetype create "${COLLECTION}"_Product_SP07 "FALSE_COLOR" --traceback \
      --red "nir" \
      --green "red" \
      --blue "green" \
      --red-range 1000 20000 \
      --green-range 1000 20000 \
      --blue-range 1000 20000 \
      --red-nodata 0 \
      --green-nodata 0 \
      --blue-nodata 0
  python3 manage.py browsetype create "${COLLECTION}"_Product_SP07 "NDVI" --traceback \
      --grey "(nir-red)/(nir+red)" --grey-range -1 1
  # SW00
  python3 manage.py producttype create "${COLLECTION}"_Product_SW00 --traceback \
      --coverage-type "RGBNir"
  python3 manage.py browsetype create "${COLLECTION}"_Product_SW00 --traceback \
      --red "red" \
      --green "green" \
      --blue "blue" \
      --red-range 100 1500 \
      --green-range 100 1500 \
      --blue-range 100 1500 \
      --red-nodata 0 \
      --green-nodata 0 \
      --blue-nodata 0
  python3 manage.py browsetype create "${COLLECTION}"_Product_SW00 "TRUE_COLOR" --traceback \
      --red "red" \
      --green "green" \
      --blue "blue" \
      --red-range 100 1500 \
      --green-range 100 1500 \
      --blue-range 100 1500 \
      --red-nodata 0 \
      --green-nodata 0 \
      --blue-nodata 0
  python3 manage.py browsetype create "${COLLECTION}"_Product_SW00 "FALSE_COLOR" --traceback \
      --red "nir" \
      --green "red" \
      --blue "green" \
      --red-range 100 1500 \
      --green-range 100 1500 \
      --blue-range 100 1500 \
      --red-nodata 0 \
      --green-nodata 0 \
      --blue-nodata 0
  python3 manage.py browsetype create "${COLLECTION}"_Product_SW00 "NDVI" --traceback \
      --grey "(nir-red)/(nir+red)" --grey-range -1 1
  # TR00
  python3 manage.py producttype create "${COLLECTION}"_Product_TR00 --traceback \
      --coverage-type "RGBNir"
  python3 manage.py browsetype create "${COLLECTION}"_Product_TR00 --traceback \
      --red "red" \
      --green "green" \
      --blue "blue" \
      --red-range 1 3000 \
      --green-range 1 3000 \
      --blue-range 1 3000 \
      --red-nodata 0 \
      --green-nodata 0 \
      --blue-nodata 0
  python3 manage.py browsetype create "${COLLECTION}"_Product_TR00 "TRUE_COLOR" --traceback \
      --red "red" \
      --green "green" \
      --blue "blue" \
      --red-range 1 3000 \
      --green-range 1 3000 \
      --blue-range 1 3000 \
      --red-nodata 0 \
      --green-nodata 0 \
      --blue-nodata 0
  python3 manage.py browsetype create "${COLLECTION}"_Product_TR00 "FALSE_COLOR" --traceback \
      --red "nir" \
      --green "red" \
      --blue "green" \
      --red-range 1 3000 \
      --green-range 1 3000 \
      --blue-range 1 3000 \
      --red-nodata 0 \
      --green-nodata 0 \
      --blue-nodata 0
  python3 manage.py browsetype create "${COLLECTION}"_Product_TR00 "NDVI" --traceback \
      --grey "(nir-red)/(nir+red)" --grey-range -1 1
  python3 manage.py collectiontype create "${COLLECTION}"_Collection --traceback \
      --coverage-type "RGBNir" \
      --product-type "${COLLECTION}"_Product_PL00 \
      --product-type "${COLLECTION}"_Product_DM02 \
      --product-type "${COLLECTION}"_Product_KS03 \
      --product-type "${COLLECTION}"_Product_KS04 \
      --product-type "${COLLECTION}"_Product_PH1A \
      --product-type "${COLLECTION}"_Product_PH1B \
      --product-type "${COLLECTION}"_Product_SP06 \
      --product-type "${COLLECTION}"_Product_SP07 \
      --product-type "${COLLECTION}"_Product_SW00 \
      --product-type "${COLLECTION}"_Product_TR00
  # Create collections for all/Level-1/Level-3 products
  python3 manage.py collection create "${COLLECTION}" --type "${COLLECTION}"_Collection --traceback
  python3 manage.py collection create "${COLLECTION}_Level_1" --type "${COLLECTION}"_Collection --traceback
  python3 manage.py collection create "${COLLECTION}_Level_3" --type "${COLLECTION}"_Collection --traceback
  # Register mask type
  python3 manage.py masktype create --validity "${COLLECTION}"_Product_PL00 validity
  python3 manage.py masktype create --validity "${COLLECTION}"_Product_DM02 validity
  python3 manage.py masktype create --validity "${COLLECTION}"_Product_KS03 validity
  python3 manage.py masktype create --validity "${COLLECTION}"_Product_KS04 validity
  python3 manage.py masktype create --validity "${COLLECTION}"_Product_PH1A validity
  python3 manage.py masktype create --validity "${COLLECTION}"_Product_PH1B validity
  python3 manage.py masktype create --validity "${COLLECTION}"_Product_SP06 validity
  python3 manage.py masktype create --validity "${COLLECTION}"_Product_SP07 validity
  python3 manage.py masktype create --validity "${COLLECTION}"_Product_SW00 validity
  python3 manage.py masktype create --validity "${COLLECTION}"_Product_TR00 validity
}

id_check=$(python3 manage.py id check "${COLLECTION}")
if [[ $id_check == *"is already in use by a 'Collection'"* ]]; then
  # name is already taken
  echo "Using existing database"
elif [[ $id_check == *"is currently not in use"* ]]; then
  initialize
else
  echo "Restarting service inside init-db by emitting an error"
  set -eo pipefail
  false
fi
